Index: GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoTreeSimplifier.cpp
===================================================================
--- GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoTreeSimplifier.cpp	(revision 998)
+++ GTP/trunk/Lib/Geom/shared/GTGeometry/src/GeoTreeSimplifier.cpp	(revision 1007)
@@ -4,19 +4,31 @@
 #include <iostream>
 #include <fstream>
-#include <ctime>
 
 using namespace Geometry;
 using namespace std;
 
-TreeSimplifier::TreeSimplifier(	const	Mesh	*m,
-																TIPOFUNC		upb)
-{
-	objmesh						=	m;
-	mtreesimpsequence	=	new Geometry::TreeSimplificationSequence();
-	//mtreesimpsequence=NULL;
-	activas	=	0;
-	counth	=	0;
-
-	// Mesh de salida
+const int VISIT_PARENTS_DEEP=1;
+
+class LeafOctree
+{
+public:
+	float left, right, bottom, top, front, back;
+	std::vector<int> leaves; ///< leaves that are too much big to fit in any of the child leaves of this octree leaf
+	LeafOctree* parent;
+	LeafOctree* children[8];
+	bool PointInsideOctree(float x, float y, float z) const {
+		return (x>=left && x<=right && y>=bottom && y<=top && z>=front && z<=back);
+	}
+	bool HasChildren(void) const { return (children[0] && children[1] && children[2] && children[3] && children[4] && children[5] && children[6] && children[7]); }
+};
+
+TreeSimplifier::TreeSimplifier(const Mesh *m, TIPOFUNC upb)
+{
+	objmesh	= m;
+	mtreesimpsequence = new Geometry::TreeSimplificationSequence();
+	activeLeaves =	0;
+	countLeaves	 =	0;
+
+	// Output mesh
 	mesh	=	new Geometry::Mesh();
 	*mesh	=	*m;
@@ -41,103 +53,106 @@
 	return	mtreesimpsequence;
 }
-
+/*#include <time.h> // necesario para gettickcount
+#include <map>*/
 void TreeSimplifier::Simplify(Real lodfactor,	Index meshLeaves)
 {
-	// paramlod indica el número de vértices
 	long	int	totalv;
-	long	int	hnueva;
-	float			diam;
-
-	//	2006-02-22
-	float			percent;
-	long	int	update;
-	
+	long	int	newleaf;
+	float	diam;
+
 	totalv	=	0;
-	
-	Mesh2Estructura(objmesh, meshLeaves);
-	
-	diam = DiametroEsferaEnvolvente();
-
-	EstableceCriterio(diam);
-
-	float paramlod = lodfactor * activas * 0.01f;
-
-	// El paramlod lo uso como condición de parada de la simplificación
-	if (paramlod >= 6)
-	{
-		//	2006-02-22
-		update	=	long((activas - (6 * paramlod)) / 80);
-		percent	=	0.5;
-		
-		while ( activas > (6*paramlod))
-		{
-			//	2006-02-22
-			if (mUPB	&&	(((long int)(activas - (6 * paramlod)) % update) == 0))
-			{
-				mUPB(percent);
-			}
-			
-			hnueva	=	Colapsa(diam);
-			
-			EstableceCriterio2(diam, hnueva);
-		}
-	}
-	else
-	{
-		//	2006-02-22
-		update	=	(activas - 6) / 80;
-		percent	=	0.5;
-		
-		while ( activas > 6) 
-		{
-			//	2006-02-22
-			if (mUPB	&&	(((activas - 6) % update) == 0))
-			{
-				mUPB(percent);
-			}
-			
-			hnueva	=	Colapsa(diam);
-			
-			EstableceCriterio2(diam, hnueva);
-		}
-	}
-
-	EscribeMesh(meshLeaves);
-	
-	//	2006-02-22
-	//	Fit progress bar to 100%.
-	if (mUPB)
-	{
-		mUPB(40);
-	}
-}
-
-void TreeSimplifier::Mesh2Estructura(	const Mesh	*mesh,
-																			Index				meshLeaves)
-{
-	// Calcular el número de vértices
+
+/*	// DEBUG
+	FILE *f = fopen("timelog.txt","wt");
+	int initime = time(0);
+	fprintf(f,"initime: %d", initime); fflush(f);
+	// DEBUG*/
+	
+	Mesh2Structure(objmesh, meshLeaves);
+	
+	diam = BoundingSphereDiameter();
+
+	// precalculate the octree to speed up the simplification process
+	const int octree_deep = 2;
+	octree=CreateLeafOctree(octree_deep);
+
+	SetCriteriaOptimized(diam);
+
+	int target_face_count = (int)((lodfactor*0.01f) * activeLeaves);
+	int update_each = (activeLeaves - target_face_count)/68;
+//	int prune_each = octree_deep?(activeLeaves - target_face_count)/octree_deep:0;
+	
+//	FILE *fp = fopen("pruning.txt","wt"); // DEBUG
+
+/*	std::map<float,int> hojas_x_crit;
+	for (int i=0; i<countLeaves; i++)
+		hojas_x_crit[Leaves[i].criterio] = i;
+
+	int *leaf_order = new int[countLeaves];
+	std::map<float,int>::iterator kkit = hojas_x_crit.begin();
+	for (int i=0; i<countLeaves; i++, kkit++)
+		leaf_order[i] = kkit->second;*/
+
+//	int erased_leaves = 0;
+	while (activeLeaves > target_face_count)
+	{
+		static int erased_faces_since_last_update = 0;
+		if (mUPB && erased_faces_since_last_update >= update_each)
+		{
+			erased_faces_since_last_update=0;
+			mUPB(1);
+		}
+
+/*		static int erased_faces_since_last_prune = 0;
+		if (octree_deep && erased_faces_since_last_prune >= prune_each)
+		{
+			erased_faces_since_last_prune=0;
+			int pruneinitime = time(0);
+			PruneOctree(octree);
+			int prunefintime = time(0);
+			// DEBUG			
+			fprintf(fp,"pruning at %d activeLeaves [%d (s)]\n", activeLeaves, prunefintime-pruneinitime); fflush(f);
+			// DEBUG
+		}*/
+
+		erased_faces_since_last_update++;				
+//		erased_faces_since_last_prune++;
+
+		newleaf	= Collapse(diam);
+		SetCriteria2Optimized(diam, newleaf);
+//		erased_leaves++;
+	}
+
+//	fclose(fp);
+
+/*	int fintime = time(0);
+	fprintf(f,"fintime: %d",fintime); fflush(f);
+	fprintf(f,"total: %d (s)",fintime-initime); fflush(f);
+	fclose(f);*/
+
+	BuildOutputMesh(meshLeaves);	
+}
+
+void TreeSimplifier::Mesh2Structure(const Mesh *mesh, Index meshLeaves)
+{
 	long int countv=0;
 	long int pos=0;
 	long int v1, v2, v3;
-	long int num_triangulo=0; // Identifica los triángulos en las hojas
-
-	//	2006-02-21.
-	float			percent;
-	long	int	update;
-	
-	countv+=(long int)mesh->mSubMesh[meshLeaves].mVertexBuffer->mVertexCount;
+	long int triangleID=0;
+
+	countv += vertex_count = (int)mesh->mSubMesh[meshLeaves].mVertexBuffer->mVertexCount;	
 	Vertex  = new float[2*countv][3];
-	
-	//	2006-02-21.
-	update	=	long(mesh->mSubMesh[meshLeaves].mVertexBuffer->mVertexCount / 20);
-	percent	=	0.5;
+		
+	int update_each = (int)(mesh->mSubMesh[meshLeaves].mVertexBuffer->mVertexCount / 5);
 	
 	for (unsigned int j=0; j<mesh->mSubMesh[meshLeaves].mVertexBuffer->mVertexCount; j++)
 	{
-		//	2006-02-21.
-		if (mUPB	&&	((j % update) == 0))
-		{
-			mUPB(percent);
-		}
+		static int ticks_since_last_update = 0;
+		if (mUPB && ticks_since_last_update>=update_each)
+		{
+			ticks_since_last_update=0;
+			mUPB(1);
+		}
+		ticks_since_last_update++;
 		
 		Vertex[pos][0] = mesh->mSubMesh[meshLeaves].mVertexBuffer->mPosition[j].x; 
@@ -147,54 +162,53 @@
 	}
 
-	// Calcular el número de hojas
-	counth+=(long)mesh->mSubMesh[meshLeaves].mIndexCount;
-	counth=counth/6; // Se supone que cada 6 índices forman una hoja.
-
-	if ( counth > 0)
-	{
-		Hojasa  = new Hoja[2*counth];
-	}
-
-	activas = counth;
-
-	// Insertar las hojas en la estructura
+	// Calculate the number of leaves
+	countLeaves += (long)mesh->mSubMesh[meshLeaves].mIndexCount;
+	countLeaves=countLeaves/6; // Each leaf is composed of 6 indices
+
+	if (countLeaves > 0)
+		Leaves = new Hoja[2*countLeaves];
+
+	activeLeaves = countLeaves;
+
+	// Insert leaves into the structure
 	pos=0;
 
-	update	=	long(mesh->mSubMesh[meshLeaves].mIndexCount	/ 20);
-	percent	=	0.5;
-	
-	// Cada hoja son 6 vértices
+	update_each = (int)(mesh->mSubMesh[meshLeaves].mIndexCount / 5);
+	
+	// Each leaf is composed of 6 vertices
 	for (unsigned int j=0; j<mesh->mSubMesh[meshLeaves].mIndexCount; j=j+6) 
 	{
-		//	2006-02-21.
-		if (mUPB	&&	((j % update) == 0))
-		{
-			mUPB(percent);
-		}
+		static int ticks_since_last_update = 0;
+		if (mUPB && ticks_since_last_update>=update_each)
+		{
+			ticks_since_last_update=0;
+			mUPB(1);
+		}
+		ticks_since_last_update+=6;
 		
-		// Primer triángulo
+		// first triangle
 		v1=mesh->mSubMesh[meshLeaves].mIndex[j];
 		v2=mesh->mSubMesh[meshLeaves].mIndex[j+1];
 		v3=mesh->mSubMesh[meshLeaves].mIndex[j+2];
-		Hojasa[pos].Vert_Hoja[0]=v1;
-		Hojasa[pos].Vert_Hoja[1]=v2;
-		Hojasa[pos].Vert_Hoja[2]=v3;
-		Hojasa[pos].id_triangulo[0]=num_triangulo;
-		Hojasa[pos].existe=true;
-		num_triangulo++;
-
-		// Segundo triángulo
+		Leaves[pos].Vert_Hoja[0]=v1;
+		Leaves[pos].Vert_Hoja[1]=v2;
+		Leaves[pos].Vert_Hoja[2]=v3;
+		Leaves[pos].id_triangulo[0]=triangleID;
+		Leaves[pos].existe=true;
+		triangleID++;
+
+		// second triangle
 		v3=mesh->mSubMesh[meshLeaves].mIndex[j+5];
-		Hojasa[pos].Vert_Hoja[3]=v3;
-		Hojasa[pos].id_triangulo[1]=num_triangulo;
-		num_triangulo++;
-
-		Centroh(Hojasa[pos]);
-		GetNormal(Hojasa[pos]);
+		Leaves[pos].Vert_Hoja[3]=v3;
+		Leaves[pos].id_triangulo[1]=triangleID;
+		triangleID++;
+
+		CalculateLeafCenter(Leaves[pos]);
+		CalculateLeafNormal(Leaves[pos]);
 		pos++;
 	}
 }
 
-float TreeSimplifier::max(float a,	float b)
+float TreeSimplifier::max(float a,	float b) const
 {
 	if (a>b) return (a);
@@ -202,5 +216,5 @@
 }
 
-float TreeSimplifier::min(float a,	float b)
+float TreeSimplifier::min(float a,	float b) const
 {
 	if (a>b) return (b);
@@ -208,20 +222,11 @@
 }
 
-float TreeSimplifier::distan(	float	x1,	float	y1,	float	z1,
-															float x2,	float y2,	float z2)
-{
-	float dist = 0;
-
-	dist = ((x2-x1)*(x2-x1)) + ((y2-y1)*(y2-y1)) + ((z2-z1)*(z2-z1));
-
-	return ( dist);
-}
-
-//--------------------------------------------------------------------------------------------------------------------------------
-//  CALCULA EL CENTRO DE UNA HOJA
-//--------------------------------------------------------------------------------------------------------------------------------
-
-
-void TreeSimplifier::Centroh(Hoja	&Hoja1)
+float TreeSimplifier::distan(float x1, float y1, float z1, float x2, float y2, float z2) const
+{
+	return ((x2-x1)*(x2-x1)) + ((y2-y1)*(y2-y1)) + ((z2-z1)*(z2-z1));
+}
+
+// Calculates the center of a leaf
+void TreeSimplifier::CalculateLeafCenter(Hoja &auxleaf)
 {
 	float	max_x;
@@ -233,47 +238,34 @@
 	
 	//x1
-	max_x	=	max(max(Vertex[Hoja1.Vert_Hoja[0]][0],
-									Vertex[Hoja1.Vert_Hoja[1]][0]),
-				  		max(Vertex[Hoja1.Vert_Hoja[2]][0],
-									Vertex[Hoja1.Vert_Hoja[3]][0]));
-	
-	min_x	=	min(min(Vertex[Hoja1.Vert_Hoja[0]][0],
-									Vertex[Hoja1.Vert_Hoja[1]][0]),
-				  		min(Vertex[Hoja1.Vert_Hoja[2]][0],
-									Vertex[Hoja1.Vert_Hoja[3]][0]));
-
-	Hoja1.Centro[0] = (max_x + min_x)/2;
+	max_x	=	max(max(Vertex[auxleaf.Vert_Hoja[0]][0],Vertex[auxleaf.Vert_Hoja[1]][0]),
+				    max(Vertex[auxleaf.Vert_Hoja[2]][0],Vertex[auxleaf.Vert_Hoja[3]][0]));
+	
+	min_x	=	min(min(Vertex[auxleaf.Vert_Hoja[0]][0],Vertex[auxleaf.Vert_Hoja[1]][0]),
+				  	min(Vertex[auxleaf.Vert_Hoja[2]][0],Vertex[auxleaf.Vert_Hoja[3]][0]));
+
+	auxleaf.Centro[0] = (max_x + min_x)/2;
 
 	//y1
-	max_y	=	max(max(Vertex[Hoja1.Vert_Hoja[0]][1],
-									Vertex[Hoja1.Vert_Hoja[1]][1]),
-				  		max(Vertex[Hoja1.Vert_Hoja[2]][1],
-									Vertex[Hoja1.Vert_Hoja[3]][1]));
-	
-	min_y	=	min(min(Vertex[Hoja1.Vert_Hoja[0]][1],
-									Vertex[Hoja1.Vert_Hoja[1]][1]),
-				  		min(Vertex[Hoja1.Vert_Hoja[2]][1],
-									Vertex[Hoja1.Vert_Hoja[3]][1]));
-
-	Hoja1.Centro[1]	=	(max_y + min_y) / 2;
+	max_y	=	max(max(Vertex[auxleaf.Vert_Hoja[0]][1],Vertex[auxleaf.Vert_Hoja[1]][1]),
+				  	max(Vertex[auxleaf.Vert_Hoja[2]][1],Vertex[auxleaf.Vert_Hoja[3]][1]));
+	
+	min_y	=	min(min(Vertex[auxleaf.Vert_Hoja[0]][1],Vertex[auxleaf.Vert_Hoja[1]][1]),
+				  	min(Vertex[auxleaf.Vert_Hoja[2]][1],Vertex[auxleaf.Vert_Hoja[3]][1]));
+
+	auxleaf.Centro[1]	=	(max_y + min_y) / 2;
 	
 	//z1
-	max_z	=	max(max(Vertex[Hoja1.Vert_Hoja[0]][2],
-									Vertex[Hoja1.Vert_Hoja[1]][2]),
-				  		max(Vertex[Hoja1.Vert_Hoja[2]][2],
-									Vertex[Hoja1.Vert_Hoja[3]][2]));
-	
-	min_z	=	min(min(Vertex[Hoja1.Vert_Hoja[0]][2],
-									Vertex[Hoja1.Vert_Hoja[1]][2]),
-				  		min(Vertex[Hoja1.Vert_Hoja[2]][2],
-									Vertex[Hoja1.Vert_Hoja[3]][2]));
-
-	Hoja1.Centro[2]	=	(max_z + min_z) / 2;
-}
-
-//--------------------------------------------------------------------------------------------------------------------------------
-//  CALCULA LA NORMAL DE UNA HOJA
-//--------------------------------------------------------------------------------------------------------------------------------
-void TreeSimplifier::GetNormal(Hoja &aHoja)
+	max_z	=	max(max(Vertex[auxleaf.Vert_Hoja[0]][2],Vertex[auxleaf.Vert_Hoja[1]][2]),
+				  	max(Vertex[auxleaf.Vert_Hoja[2]][2],Vertex[auxleaf.Vert_Hoja[3]][2]));
+	
+	min_z	=	min(min(Vertex[auxleaf.Vert_Hoja[0]][2],Vertex[auxleaf.Vert_Hoja[1]][2]),
+				  	min(Vertex[auxleaf.Vert_Hoja[2]][2],Vertex[auxleaf.Vert_Hoja[3]][2]));
+
+	auxleaf.Centro[2]	=	(max_z + min_z) / 2;
+}
+
+
+//  calculate the normal vector of a leaf
+void TreeSimplifier::CalculateLeafNormal(Hoja &auxleaf)
 {
 	float onex, oney, onez;
@@ -281,18 +273,16 @@
 	float threex, threey, threez;
 
-	onex=Vertex[aHoja.Vert_Hoja[0]][0]; oney= Vertex[aHoja.Vert_Hoja[0]][1]; onez = Vertex[aHoja.Vert_Hoja[0]][2];
-	twox = Vertex[aHoja.Vert_Hoja[1]][0]; twoy = Vertex[aHoja.Vert_Hoja[1]][1]; twoz = Vertex[aHoja.Vert_Hoja[1]][2];
-	threex = Vertex[aHoja.Vert_Hoja[2]][0]; threey = Vertex[aHoja.Vert_Hoja[2]][1]; threez = Vertex[aHoja.Vert_Hoja[2]][2];
-	
-	aHoja.Normal[0] = ((twoz-onez)*(threey-oney)) - ((twoy-oney)*(threez-onez));
-	aHoja.Normal[1] = ((twox-onex)*(threez-onez)) - ((threex-onex)*(twoz-onez));
-	aHoja.Normal[2] = ((threex-onex)*(twoy-oney)) - ((twox-onex)*(threey-oney));
-
-	
-}
-//--------------------------------------------------------------------------------------------------------------------------------
-//  CALCULA LA distancia de Hausdorff ( distancia entre nubes de puntos)
-//--------------------------------------------------------------------------------------------------------------------------------
-float TreeSimplifier::Hausdorff(Hoja &aHoja, Hoja& h2)
+	onex   = Vertex[auxleaf.Vert_Hoja[0]][0]; oney   = Vertex[auxleaf.Vert_Hoja[0]][1]; onez   = Vertex[auxleaf.Vert_Hoja[0]][2];
+	twox   = Vertex[auxleaf.Vert_Hoja[1]][0]; twoy   = Vertex[auxleaf.Vert_Hoja[1]][1]; twoz   = Vertex[auxleaf.Vert_Hoja[1]][2];
+	threex = Vertex[auxleaf.Vert_Hoja[2]][0]; threey = Vertex[auxleaf.Vert_Hoja[2]][1]; threez = Vertex[auxleaf.Vert_Hoja[2]][2];
+	
+	auxleaf.Normal[0] = ((twoz-onez)*(threey-oney)) - ((twoy-oney)*(threez-onez));
+	auxleaf.Normal[1] = ((twox-onex)*(threez-onez)) - ((threex-onex)*(twoz-onez));
+	auxleaf.Normal[2] = ((threex-onex)*(twoy-oney)) - ((twox-onex)*(threey-oney));	
+}
+
+
+//  calculate the Hausdorff distance (distance between point clouds)
+/*float TreeSimplifier::Hausdorff(Hoja &leaf1, Hoja& leaf2) const
 {
 	float onex, oney, onez;
@@ -306,18 +296,16 @@
 	float dist1, dist2, dist3, dist4, distmp, dista, distb, dist;
 
-	onex=Vertex[aHoja.Vert_Hoja[0]][0]; oney= Vertex[aHoja.Vert_Hoja[0]][1]; onez = Vertex[aHoja.Vert_Hoja[0]][2];
-	twox = Vertex[aHoja.Vert_Hoja[1]][0]; twoy = Vertex[aHoja.Vert_Hoja[1]][1]; twoz = Vertex[aHoja.Vert_Hoja[1]][2];
-	threex = Vertex[aHoja.Vert_Hoja[2]][0]; threey = Vertex[aHoja.Vert_Hoja[2]][1]; threez = Vertex[aHoja.Vert_Hoja[2]][2];
-	fourx = Vertex[aHoja.Vert_Hoja[3]][0]; foury = Vertex[aHoja.Vert_Hoja[3]][1]; fourz = Vertex[aHoja.Vert_Hoja[3]][2];
-	
-
-	x1 = Vertex[h2.Vert_Hoja[0]][0]; y1 = Vertex[h2.Vert_Hoja[0]][1]; z1 = Vertex[h2.Vert_Hoja[0]][2];
-	x2 = Vertex[h2.Vert_Hoja[1]][0]; y2 = Vertex[h2.Vert_Hoja[1]][1]; z2 = Vertex[h2.Vert_Hoja[1]][2];
-	x3 = Vertex[h2.Vert_Hoja[2]][0]; y3 = Vertex[h2.Vert_Hoja[2]][1]; z3 = Vertex[h2.Vert_Hoja[2]][2];
-	x4 = Vertex[h2.Vert_Hoja[3]][0]; y4 = Vertex[h2.Vert_Hoja[3]][1]; z4 = Vertex[h2.Vert_Hoja[3]][2];
-
-	// guardo las distancias mínimas de cada vértice a los 4 contrarios.
+	onex=Vertex[leaf1.Vert_Hoja[0]][0]; oney= Vertex[leaf1.Vert_Hoja[0]][1]; onez = Vertex[leaf1.Vert_Hoja[0]][2];
+	twox = Vertex[leaf1.Vert_Hoja[1]][0]; twoy = Vertex[leaf1.Vert_Hoja[1]][1]; twoz = Vertex[leaf1.Vert_Hoja[1]][2];
+	threex = Vertex[leaf1.Vert_Hoja[2]][0]; threey = Vertex[leaf1.Vert_Hoja[2]][1]; threez = Vertex[leaf1.Vert_Hoja[2]][2];
+	fourx = Vertex[leaf1.Vert_Hoja[3]][0]; foury = Vertex[leaf1.Vert_Hoja[3]][1]; fourz = Vertex[leaf1.Vert_Hoja[3]][2];
+	
+
+	x1 = Vertex[leaf2.Vert_Hoja[0]][0]; y1 = Vertex[leaf2.Vert_Hoja[0]][1]; z1 = Vertex[leaf2.Vert_Hoja[0]][2];
+	x2 = Vertex[leaf2.Vert_Hoja[1]][0]; y2 = Vertex[leaf2.Vert_Hoja[1]][1]; z2 = Vertex[leaf2.Vert_Hoja[1]][2];
+	x3 = Vertex[leaf2.Vert_Hoja[2]][0]; y3 = Vertex[leaf2.Vert_Hoja[2]][1]; z3 = Vertex[leaf2.Vert_Hoja[2]][2];
+	x4 = Vertex[leaf2.Vert_Hoja[3]][0]; y4 = Vertex[leaf2.Vert_Hoja[3]][1]; z4 = Vertex[leaf2.Vert_Hoja[3]][2];
+
 	dist1 = distan ( onex, oney,onez,x1,y1,z1);
-	// vertice 1 con los 4 de la otra hoja
 
 	distmp = distan ( onex, oney,onez,x2,y2,z2);
@@ -330,6 +318,4 @@
 	if ( distmp < dist1) dist1 = distmp;
 
-	// vertice 2 con los 4 de la otra hoja
-
 	dist2 = distan ( twox, twoy,twoz,x1,y1,z1);
 	
@@ -343,5 +329,4 @@
 	if ( distmp < dist2) dist2 = distmp;
 
-	// vertice 3 con los 4 de la otra hoja
 
 	dist3 = distan ( threex, threey,threez,x1,y1,z1);
@@ -357,5 +342,4 @@
 
 
-	// vertice 4 con los 4 de la otra hoja
 
 	dist4 = distan ( fourx, foury,fourz,x1,y1,z1);
@@ -370,12 +354,8 @@
 	if ( distmp < dist4) dist4 = distmp;
 
-	//de entre estos cojo el máximo
 
 	dista =  max(dist1, max(dist2, max(dist3, dist4)));
 
-	//LO MISMO PERO A LA INVERSA
-
 	dist1 = distan ( x1,y1,z1, onex, oney, onez);
-	// vertice 1 con los 4 de la otra hoja
 
 	distmp = distan ( x1,y1,z1, twox, twoy, twoz);
@@ -388,7 +368,5 @@
 	if ( distmp < dist1) dist1 = distmp;
 
-	//2
 	dist2 = distan ( x2,y2,z2, onex, oney, onez);
-	// vertice 2 con los 4 de la otra hoja
 
 	distmp = distan ( x2,y2,z2, twox, twoy, twoz);
@@ -404,5 +382,4 @@
 		//3
 	dist3 = distan ( x3,y3,z3, onex, oney, onez);
-	// vertice 3 con los 4 de la otra hoja
 
 	distmp = distan ( x3,y3,z3, twox, twoy, twoz);
@@ -417,5 +394,4 @@
 		//4
 	dist4 = distan ( x4,y4,z4, onex, oney, onez);
-	// vertice 4 con los 4 de la otra hoja
 
 	distmp = distan ( x4,y4,z4, twox, twoy, twoz);
@@ -435,9 +411,145 @@
 	
 }
-
-//--------------------------------------------------------------------------------------------------------------------------------
-// CALCULA LA DISTANCIA ENTRE HOJAS
-//--------------------------------------------------------------------------------------------------------------------------------
-
+*/
+
+//  Calculate the Hausdorff distance (distance between point clouds) (Optimized)
+float TreeSimplifier::HausdorffOptimized(const Hoja &leaf1, const Hoja& leaf2) const
+{
+	float onex, oney, onez;
+	float twox, twoy, twoz;
+	float threex, threey, threez;
+	float fourx, foury, fourz;
+	float x1, y1, z1;
+	float x2, y2, z2;
+	float x3, y3, z3;
+	float x4, y4, z4;
+	float dist1, dist2, dist3, dist4, distmp, dista, distb, dist;
+
+	onex   = Vertex[leaf1.Vert_Hoja[0]][0]; oney   = Vertex[leaf1.Vert_Hoja[0]][1]; onez   = Vertex[leaf1.Vert_Hoja[0]][2];
+	twox   = Vertex[leaf1.Vert_Hoja[1]][0]; twoy   = Vertex[leaf1.Vert_Hoja[1]][1]; twoz   = Vertex[leaf1.Vert_Hoja[1]][2];
+	threex = Vertex[leaf1.Vert_Hoja[2]][0]; threey = Vertex[leaf1.Vert_Hoja[2]][1]; threez = Vertex[leaf1.Vert_Hoja[2]][2];
+	fourx  = Vertex[leaf1.Vert_Hoja[3]][0]; foury  = Vertex[leaf1.Vert_Hoja[3]][1]; fourz  = Vertex[leaf1.Vert_Hoja[3]][2];
+
+	x1 = Vertex[leaf2.Vert_Hoja[0]][0]; y1 = Vertex[leaf2.Vert_Hoja[0]][1]; z1 = Vertex[leaf2.Vert_Hoja[0]][2];
+	x2 = Vertex[leaf2.Vert_Hoja[1]][0]; y2 = Vertex[leaf2.Vert_Hoja[1]][1]; z2 = Vertex[leaf2.Vert_Hoja[1]][2];
+	x3 = Vertex[leaf2.Vert_Hoja[2]][0]; y3 = Vertex[leaf2.Vert_Hoja[2]][1]; z3 = Vertex[leaf2.Vert_Hoja[2]][2];
+	x4 = Vertex[leaf2.Vert_Hoja[3]][0]; y4 = Vertex[leaf2.Vert_Hoja[3]][1]; z4 = Vertex[leaf2.Vert_Hoja[3]][2];
+
+	// variables used to cache distances
+	float one1,one2,one3,one4, two1,two2,two3,two4, three1,three2,three3,three4, four1,four2,four3,four4;
+
+	// Store the minimal distances from each of the 4 vertices to the other 4 vertices
+	one1 = dist1 = distan ( onex, oney,onez,x1,y1,z1);
+	
+	one2 = distmp = distan ( onex, oney,onez,x2,y2,z2);
+	if ( distmp < dist1) dist1 = distmp;
+
+	one3 = distmp = distan ( onex, oney,onez,x3,y3,z3);
+	if ( distmp < dist1) dist1 = distmp;
+
+	one4 = distmp = distan ( onex, oney,onez,x4,y4,z4);
+	if ( distmp < dist1) dist1 = distmp;
+
+	
+	two1 = dist2 = distan ( twox, twoy,twoz,x1,y1,z1);
+	
+	two2 = distmp = distan ( twox, twoy,twoz,x2,y2,z2);
+	if ( distmp < dist2) dist2 = distmp;
+	
+	two3 = distmp = distan ( twox, twoy,twoz,x3,y3,z3);
+	if ( distmp < dist2) dist2 = distmp;
+	
+	two4 = distmp = distan ( twox, twoy,twoz,x4,y4,z4);
+	if ( distmp < dist2) dist2 = distmp;
+
+	
+	three1 = dist3 = distan ( threex, threey,threez,x1,y1,z1);
+	
+	three2 = distmp = distan ( threex, threey,threez,x2,y2,z2);
+	if ( distmp < dist3) dist3 = distmp;
+
+	three3 = distmp = distan ( threex, threey,threez,x3,y3,z3);
+	if ( distmp < dist3) dist3 = distmp;
+
+	three4 = distmp = distan ( threex, threey,threez,x4,y4,z4);
+	if ( distmp < dist3) dist3 = distmp;
+
+
+	four1 = dist4 = distan ( fourx, foury,fourz,x1,y1,z1);
+	
+	four2 = distmp = distan ( fourx, foury,fourz,x2,y2,z2);
+	if ( distmp < dist4) dist4 = distmp;
+
+	four3 = distmp = distan ( fourx, foury,fourz,x3,y3,z3);
+	if ( distmp < dist4) dist4 = distmp;
+	
+	four4 = distmp = distan ( fourx, foury,fourz,x4,y4,z4);
+	if ( distmp < dist4) dist4 = distmp;
+
+	// pick up the maximum value from those 4
+
+	dista =  max(dist1, max(dist2, max(dist3, dist4)));
+
+	// now use the cached distances to perform the reverse distances
+
+	dist1 = one1;  //distan ( x1,y1,z1, onex, oney, onez);
+
+	distmp = two1; //distan ( x1,y1,z1, twox, twoy, twoz);
+	if ( distmp < dist1) dist1 = distmp;
+
+	distmp =  three1; //distan ( x1,y1,z1, threex, threey, threez);
+	if ( distmp < dist1) dist1 = distmp;
+
+	distmp = four1; //distan ( x1,y1,z1, fourx, foury, fourz);
+	if ( distmp < dist1) dist1 = distmp;
+
+	//2
+	dist2 = one2; //distan ( x2,y2,z2, onex, oney, onez);
+
+	distmp = two2; //distan ( x2,y2,z2, twox, twoy, twoz);
+	if ( distmp < dist2) dist2 = distmp;
+
+	distmp = three2; //distan ( x2,y2,z2, threex, threey, threez);
+	if ( distmp < dist2) dist2 = distmp;
+
+	distmp = four2; //distan ( x2,y2,z2, fourx, foury, fourz);
+	if ( distmp < dist2) dist2 = distmp;
+
+
+		//3
+	dist3 = one3; //distan ( x3,y3,z3, onex, oney, onez);
+
+	distmp = two3; //distan ( x3,y3,z3, twox, twoy, twoz);
+	if ( distmp < dist3) dist3 = distmp;
+
+	distmp = three3; //distan ( x3,y3,z3, threex, threey, threez);
+	if ( distmp < dist3) dist3 = distmp;
+
+	distmp = four3; //distan ( x3,y3,z3, fourx, foury, fourz);
+	if ( distmp < dist3) dist3 = distmp;
+
+		//4
+	dist4 = one4; //distan ( x4,y4,z4, onex, oney, onez);
+
+	distmp = two4; //distan ( x4,y4,z4, twox, twoy, twoz);
+	if ( distmp < dist4) dist4 = distmp;
+
+	distmp = three4; //distan ( x4,y4,z4, threex, threey, threez);
+	if ( distmp < dist4) dist4 = distmp;
+
+	distmp = four4; //distan ( x4,y4,z4, fourx, foury, fourz);
+	if ( distmp < dist4) dist4 = distmp;
+
+	//
+	distb =  max(dist1, max(dist2, max(dist3, dist4)));
+
+	dist  = max ( dista, distb);
+	return ( dist);
+	
+}
+
+
+// Calculate the distance between leaves
+/*
 void TreeSimplifier::DistanciaEntreHojas(void)
 {
@@ -445,80 +557,70 @@
 	int j;
 
-	for ( int i=0;i<counth;i++)
-	{
-		if ( Hojasa[i].existe == true) // si la hoja aun existe
+	for ( int i=0;i<countLeaves;i++)
+	{
+		if ( Leaves[i].existe == true) // si la hoja aun existe
 		{
 			// inicializo para poder comparar
-			if ( i == (counth-1)) j = 0; 
+			if ( i == (countLeaves-1)) j = 0; 
 				else j = i+1;
-			while (Hojasa[j].existe == false) j++;
-			//dist = Hojasa[i].Distancia(Hojasa[j]);
-			dist = Hausdorff( Hojasa[i], Hojasa[j]);
-
-			Hojasa[i].hoja_cerca = j;
+			while (Leaves[j].existe == false) j++;
+			//dist = Leaves[i].Distancia(Leaves[j]);
+			dist = HausdorffOptimizado( Leaves[i], Leaves[j]);
+
+			Leaves[i].hoja_cerca = j;
 			// empiezo los calculos
-			for ( j =0; j<(counth-1);j++)
+			for ( j =0; j<(countLeaves-1);j++)
 			{
 				if ( j == i) 
 					break;
-				if ( Hojasa[j].existe == true) // si la hoja aun existe
+				if ( Leaves[j].existe == true) // si la hoja aun existe
 				{
-					distmp = Hausdorff(Hojasa[i], Hojasa[j]);
+					distmp = HausdorffOptimizado(Leaves[i], Leaves[j]);
 					if ( distmp < dist ) 
 					{
 						dist = distmp;
-						Hojasa[i].hoja_cerca = j;
+						Leaves[i].hoja_cerca = j;
 					}
 				}
 				
 			}
-			Hojasa[i].dist = dist;
-		}
-	}
-
-}
-
-//--------------------------------------------------------------------------------------------------------------------------------
-// DEVUELVE LA HOJA QUE TIENE UNA DISTANCIA MENOR
-//--------------------------------------------------------------------------------------------------------------------------------
-long int TreeSimplifier::MinimaDistancia ( void)
-{
-	float			mindist;
-	long int	cual;
-	int				i;
-
-	mindist =	0;
-	cual		=	-1;
-	i				=	0;
-	
-	//inicializo
-	while (Hojasa[i].existe != true)
-	{
+			Leaves[i].dist = dist;
+		}
+	}
+
+}*/
+
+// Returns the leaf which distance is the lowest
+long int TreeSimplifier::MinDistance(void)
+{
+	float		mindist=0.0f;
+	long int	which=-1;
+	int			i=0;
+
+/*	//init
+	while (Leaves[i].existe != true)
 		i++;
-	}
-	
-	mindist =	Hojasa[i].dist;
-	cual		=	i;
-	
-	//busco la minima
-	for (i = 0; i < counth; i++)
-	{
-		if (Hojasa[i].existe == true)
-		{
-			if ( mindist > Hojasa[i].dist)
+	
+	mindist = Leaves[i].dist;
+	which	= i;
+*/	
+	// search the minimum
+	for (i = 0; i < countLeaves; i++)
+	{
+		if (Leaves[i].existe)
+		{
+			if (mindist > Leaves[i].dist || which==-1)
 			{
-				mindist = Hojasa[i].dist;
-				cual = i;
+				mindist = Leaves[i].dist;
+				which = i;
 			}
 		}
 
 	}
-	return (cual);
-}
-
-//--------------------------------------------------------------------------------------------------------------------------------
-// CALCULA LA COPLANARIDAD ENTRE HOJAS
-//--------------------------------------------------------------------------------------------------------------------------------
-void TreeSimplifier::CoplanarEntreHojas(FILE	*fp_coplanar)
+	return which;
+}
+
+// Calculate the coplanarity between leaves
+void TreeSimplifier::CoplanarBetweenLeaves(void)
 {
 	float	cop;
@@ -527,106 +629,92 @@
 	int 	j;
 
-	for ( i=0;i<counth;i++)
-	{
-		if ( Hojasa[i].existe == true) // si la hoja aun existe
-		{
-			// inicializo para poder comparar
-			if ( i == (counth-1))
+	for (i=0;i<countLeaves;i++)
+	{
+		if (Leaves[i].existe)
+		{
+			if (i == countLeaves-1)
+				j	=	0;
+			else
+				j =	i + 1;
+			
+			while (Leaves[j].existe == false)
+				j++;
+			
+			cop	= Leaves[i].Coplanaridad(Leaves[j]);
+			Leaves[i].hoja_cop	=	j;
+			
+			for (j=0; j<countLeaves-1; j++)
 			{
-				j	=	0;
-			}
-			else
-			{
-				j =	i + 1;
-			}
-			
-			while (Hojasa[j].existe == false)
-			{
-				j++;
-			}
-			
-			cop									=	Hojasa[i].Coplanaridad(Hojasa[j]);
-			Hojasa[i].hoja_cop	=	j;
-			
-			// empiezo los calculos
-			for (j = 0; j < (counth-1); j++)
-			{
-				// si la hoja aun existe.
-				if (( j != i) && (Hojasa[j].existe == true))
+				if (( j != i) && (Leaves[j].existe))
 				{
-					coptmp	=	Hojasa[i].Coplanaridad(Hojasa[j]);
-
-					// COJO EL MAS COPLANAR , CERCANO A 1.
+					coptmp	=	Leaves[i].Coplanaridad(Leaves[j]);
+
+					// Take the most coplanar: close to 1
 					if (coptmp > cop)
 					{
-						cop									=	coptmp;
-						Hojasa[i].hoja_cop	=	j;
+						cop	= coptmp;
+						Leaves[i].hoja_cop = j;
 					}
 				}
 			}
-			Hojasa[i].coplanar	=	1 - cop; //  8/6/01 LO INVIERTO
-		}
-	}
-}
-
-//--------------------------------------------------------------------------------------------------------------------------------
-// 
-//--------------------------------------------------------------------------------------------------------------------------------
-void TreeSimplifier::DosMayores(float *mayores, int	*indices)
+			Leaves[i].coplanar = 1 - cop;
+		}
+	}
+}
+
+void TreeSimplifier::TwoGreater(float *maj, int	*indices)
 {
 	float	m1;
 	int		i;
 
-	if	(mayores[0] < mayores[1])
-	{
-		m1					=	mayores[0];
-		mayores[0]	=	mayores[1];
-		mayores[1]	=	m1;
-
-		i						=	indices[0];
-		indices[0]	=	indices[1];
-		indices[1]	=	i;
-	}
-
-	if (mayores [2] < mayores [3])
-	{
-		m1					=	mayores[2];
-		mayores[2]	=	mayores[3];
-		mayores [3]	=	m1;
-
-		i						=	indices[2];
+	if	(maj[0] < maj[1])
+	{
+		m1	= maj[0];
+		maj[0] = maj[1];
+		maj[1] = m1;
+
+		i =	indices[0];
+		indices[0] = indices[1];
+		indices[1] = i;
+	}
+
+	if (maj[2] < maj[3])
+	{
+		m1	= maj[2];
+		maj[2] = maj[3];
+		maj[3]	= m1;
+		i	= indices[2];
+		indices[2] = indices[3];
+		indices[3] = i;
+	}
+
+	if  (maj[0] < maj[2])
+	{
+		m1		=	maj[0];
+		maj[0]	=	maj[2];
+		maj[2]	=	m1;
+		i		=	indices[0];
+		indices[0]	=	indices[2];
+		indices[2]	=	i;
+	}
+
+	if (maj[2] < maj[3])
+	{
+		m1		=	maj[2];
+		maj[2]	=	maj[3];
+		maj [3]	=	m1;
+
+		i			=	indices[2];
 		indices[2]	=	indices[3];
 		indices[3]	=	i;
 	}
 
-	if  (mayores[0] < mayores[2])
-	{
-		m1					=	mayores[0];
-		mayores[0]	=	mayores[2];
-		mayores[2]	=	m1;
-
-		i						=	indices[0];
-		indices[0]	=	indices[2];
-		indices[2]	=	i;
-	}
-
-	if (mayores [2] < mayores [3])
-	{
-		m1					=	mayores[2];
-		mayores[2]	=	mayores[3];
-		mayores [3]	=	m1;
-
-		i						=	indices[2];
-		indices[2]	=	indices[3];
-		indices[3]	=	i;
-	}
-
-	if (mayores [1] < mayores [2])
-	{
-		m1					=	mayores[1];
-		mayores[1]	=	mayores[2];
-		mayores [2]	=	m1;
-
-		i						= indices[1];
+	if (maj [1] < maj [2])
+	{
+		m1		=	maj[1];
+		maj[1]	=	maj[2];
+		maj [2]	=	m1;
+
+		i			= indices[1];
 		indices[1]	= indices[2];
 		indices[2]	= i;
